package test.forum.json;
import java.net.URI;
import java.util.Date;
import java.util.List;
import java.util.Map;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyAttribute;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.namespace.QName;

@XmlAccessorType(XmlAccessType.NONE)
@XmlRootElement(name = OprEvtStatistics.XML_NAME)
@XmlType(name = OprEvtStatistics.XML_TYPE,
         propOrder = {"startDate", "endDate", "statistics", "any"})
public final class OprEvtStatistics extends OprResourceBase
{
  private static final long serialVersionUID = -7981235285649760399L;

  public static final String VERSION = "1.0";
  public static final String XML_NAME = "event_statistics";
  public static final String XML_TYPE = XML_NAME + "_type";
  public static final String TYPE = OprResourceBase.BASE_TYPE + XML_NAME;
  public static final String BASE_REF_TYPE = OprResourceBase.BASE_REF_TYPE + XML_NAME + ":";
  public static final URI TYPE_URI = URI.create(TYPE);

  private Date m_startDate;
  private Date m_endDate;
  private List<OprEvtStatisticRecord> m_stats;

  private List<Object> m_any;
  private Map<QName, Object> m_anyAttribute;

  public OprEvtStatistics()
  {
    super(TYPE_URI, VERSION);
  }

  @XmlAnyElement(lax = true)
  public List<Object> getAny()
  {
    return m_any;
  }

  @Override
  public void setAny(List<Object> any)
  {
    m_any = any;
  }

  @XmlAnyAttribute
  public Map<QName, Object> getAnyAttribute()
  {
    return m_anyAttribute;
  }

  @Override
  public void setAnyAttribute(Map<QName, Object> anyAttribute)
  {
    m_anyAttribute = anyAttribute;
  }


  @XmlElement(name = "start")
  public Date getStartDate()
  {
    return m_startDate;
  }


  public void setStartDate(Date value)
  {
    this.m_startDate = value;
  }

  @XmlElement(name = "end")
  public Date getEndDate()
  {
    return m_endDate;
  }


  public void setEndDate(Date value)
  {
    this.m_endDate = value;
  }


  @XmlElement(name = "statistic")
  public List<OprEvtStatisticRecord> getStatistics()
  {
    return m_stats;
  }


  public void setStatistics(List<OprEvtStatisticRecord> value)
  {
    this.m_stats = value;
  }

  @Override
  public int hashCode()
  {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((m_startDate == null) ? 0 : m_startDate.hashCode());
    result = prime * result + ((m_endDate == null) ? 0 : m_endDate.hashCode());
    result = prime * result + ((m_stats == null) ? 0 : m_stats.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    OprEvtStatistics other = (OprEvtStatistics) obj;

    if (m_startDate == null)
    {
      if (other.m_startDate != null)
        return false;
    }
    else if (!m_startDate.equals(other.m_startDate))
      return false;

    if (m_endDate == null)
    {
      if (other.m_endDate != null)
        return false;
    }
    else if (!m_endDate.equals(other.m_startDate))
      return false;

    if (m_stats != other.m_stats)
      return false;
    return true;
  }
}
